/* shishi_cmd.h */

/* File autogenerated by gengetopt version 2.18  */

#ifndef SHISHI_CMD_H
#define SHISHI_CMD_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "shishi"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION VERSION
#endif

struct gengetopt_args_info
{
  const char *help_help; /* Print help and exit help description.  */
  const char *version_help; /* Print version and exit help description.  */
  int destroy_flag;	/* Destroy tickets in local cache, limited by any --client-name or --server-name. (default=off).  */
  const char *destroy_help; /* Destroy tickets in local cache, limited by any --client-name or --server-name. help description.  */
  int list_flag;	/* List tickets in local cache, limited by any --client-name and --server-name. (default=off).  */
  const char *list_help; /* List tickets in local cache, limited by any --client-name and --server-name. help description.  */
  int renew_flag;	/* Renew ticket.  Use --server-name to specify ticket, default is the most recent renewable ticket granting ticket for the default realm. (default=off).  */
  const char *renew_help; /* Renew ticket.  Use --server-name to specify ticket, default is the most recent renewable ticket granting ticket for the default realm. help description.  */
  int forwardable_flag;	/* Get a forwardable ticket, i.e., one that can be used to get forwarded tickets. (default=off).  */
  const char *forwardable_help; /* Get a forwardable ticket, i.e., one that can be used to get forwarded tickets. help description.  */
  int forwarded_flag;	/* Get a forwarded ticket. (default=off).  */
  const char *forwarded_help; /* Get a forwarded ticket. help description.  */
  int proxiable_flag;	/* Get a proxiable ticket, i.e., one that can be used to get proxy tickets. (default=off).  */
  const char *proxiable_help; /* Get a proxiable ticket, i.e., one that can be used to get proxy tickets. help description.  */
  int proxy_flag;	/* Get a proxy ticket. (default=off).  */
  const char *proxy_help; /* Get a proxy ticket. help description.  */
  int renewable_flag;	/* Get a renewable ticket. (default=off).  */
  const char *renewable_help; /* Get a renewable ticket. help description.  */
  char * client_name_arg;	/* Client name. Default is login username..  */
  char * client_name_orig;	/* Client name. Default is login username. original value given at command line.  */
  const char *client_name_help; /* Client name. Default is login username. help description.  */
  char * encryption_type_arg;	/* Encryption types to use.  ETYPE is either registered name or integer.  Valid values include 'aes128', 'aes256', 'aes' (same as 'aes256'), '3des', 'des-md5', 'des-md4', 'des-crc', 'des' (same as 'des-md5'), and 'arcfour'..  */
  char * encryption_type_orig;	/* Encryption types to use.  ETYPE is either registered name or integer.  Valid values include 'aes128', 'aes256', 'aes' (same as 'aes256'), '3des', 'des-md5', 'des-md4', 'des-crc', 'des' (same as 'des-md5'), and 'arcfour'. original value given at command line.  */
  const char *encryption_type_help; /* Encryption types to use.  ETYPE is either registered name or integer.  Valid values include 'aes128', 'aes256', 'aes' (same as 'aes256'), '3des', 'des-md5', 'des-md4', 'des-crc', 'des' (same as 'des-md5'), and 'arcfour'. help description.  */
  char * endtime_arg;	/* Specify when ticket validity should expire.  The time syntax may be relative (to the start time), such as '20 hours', or absolute, such as '2001-02-03 04:05:06 CET'. The default is 8 hours after the start time..  */
  char * endtime_orig;	/* Specify when ticket validity should expire.  The time syntax may be relative (to the start time), such as '20 hours', or absolute, such as '2001-02-03 04:05:06 CET'. The default is 8 hours after the start time. original value given at command line.  */
  const char *endtime_help; /* Specify when ticket validity should expire.  The time syntax may be relative (to the start time), such as '20 hours', or absolute, such as '2001-02-03 04:05:06 CET'. The default is 8 hours after the start time. help description.  */
  char * realm_arg;	/* Set default realm..  */
  char * realm_orig;	/* Set default realm. original value given at command line.  */
  const char *realm_help; /* Set default realm. help description.  */
  char * renew_till_arg;	/* Specify renewable life of ticket.  Implies --renewable.  Accepts same time syntax as --endtime.  If --renewable is specified, the default is 1 week after the start time..  */
  char * renew_till_orig;	/* Specify renewable life of ticket.  Implies --renewable.  Accepts same time syntax as --endtime.  If --renewable is specified, the default is 1 week after the start time. original value given at command line.  */
  const char *renew_till_help; /* Specify renewable life of ticket.  Implies --renewable.  Accepts same time syntax as --endtime.  If --renewable is specified, the default is 1 week after the start time. help description.  */
  char * server_name_arg;	/* Server name. Default is 'krbtgt/REALM' where REALM is client realm..  */
  char * server_name_orig;	/* Server name. Default is 'krbtgt/REALM' where REALM is client realm. original value given at command line.  */
  const char *server_name_help; /* Server name. Default is 'krbtgt/REALM' where REALM is client realm. help description.  */
  char * starttime_arg;	/* Specify when ticket should start to be valid.  Accepts same time syntax as --endtime. The default is to become valid immediately..  */
  char * starttime_orig;	/* Specify when ticket should start to be valid.  Accepts same time syntax as --endtime. The default is to become valid immediately. original value given at command line.  */
  const char *starttime_help; /* Specify when ticket should start to be valid.  Accepts same time syntax as --endtime. The default is to become valid immediately. help description.  */
  char * ticket_granter_arg;	/* Service name in ticket to use for authenticating request. Only for TGS. Defaults to 'krbtgt/REALM@REALM' where REALM is client realm..  */
  char * ticket_granter_orig;	/* Service name in ticket to use for authenticating request. Only for TGS. Defaults to 'krbtgt/REALM@REALM' where REALM is client realm. original value given at command line.  */
  const char *ticket_granter_help; /* Service name in ticket to use for authenticating request. Only for TGS. Defaults to 'krbtgt/REALM@REALM' where REALM is client realm. help description.  */
  char * configuration_file_arg;	/* Read user configuration from FILE..  */
  char * configuration_file_orig;	/* Read user configuration from FILE. original value given at command line.  */
  const char *configuration_file_help; /* Read user configuration from FILE. help description.  */
  char * ticket_file_arg;	/* Read tickets from FILE..  */
  char * ticket_file_orig;	/* Read tickets from FILE. original value given at command line.  */
  const char *ticket_file_help; /* Read tickets from FILE. help description.  */
  char * library_options_arg;	/* Parse STRING as a configuration file statement..  */
  char * library_options_orig;	/* Parse STRING as a configuration file statement. original value given at command line.  */
  const char *library_options_help; /* Parse STRING as a configuration file statement. help description.  */
  int quiet_flag;	/* Don't produce any diagnostic output.\n (default=off).  */
  const char *quiet_help; /* Don't produce any diagnostic output.\n help description.  */
  char * system_configuration_file_arg;	/* Read system configuration from FILE..  */
  char * system_configuration_file_orig;	/* Read system configuration from FILE. original value given at command line.  */
  const char *system_configuration_file_help; /* Read system configuration from FILE. help description.  */
  char * ticket_write_file_arg;	/* Write tickets from FILE.  Default is to write them back to where they were read from..  */
  char * ticket_write_file_orig;	/* Write tickets from FILE.  Default is to write them back to where they were read from. original value given at command line.  */
  const char *ticket_write_file_help; /* Write tickets from FILE.  Default is to write them back to where they were read from. help description.  */
  int verbose_min; /* Produce verbose output.\nUse multiple times to increase amount of information.'s minimum occurreces */
  int verbose_max; /* Produce verbose output.\nUse multiple times to increase amount of information.'s maximum occurreces */
  const char *verbose_help; /* Produce verbose output.\nUse multiple times to increase amount of information. help description.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int destroy_given ;	/* Whether destroy was given.  */
  int list_given ;	/* Whether list was given.  */
  int renew_given ;	/* Whether renew was given.  */
  int forwardable_given ;	/* Whether forwardable was given.  */
  int forwarded_given ;	/* Whether forwarded was given.  */
  int proxiable_given ;	/* Whether proxiable was given.  */
  int proxy_given ;	/* Whether proxy was given.  */
  int renewable_given ;	/* Whether renewable was given.  */
  int client_name_given ;	/* Whether client-name was given.  */
  int encryption_type_given ;	/* Whether encryption-type was given.  */
  int endtime_given ;	/* Whether endtime was given.  */
  int realm_given ;	/* Whether realm was given.  */
  int renew_till_given ;	/* Whether renew-till was given.  */
  int server_name_given ;	/* Whether server-name was given.  */
  int starttime_given ;	/* Whether starttime was given.  */
  int ticket_granter_given ;	/* Whether ticket-granter was given.  */
  int configuration_file_given ;	/* Whether configuration-file was given.  */
  int ticket_file_given ;	/* Whether ticket-file was given.  */
  int library_options_given ;	/* Whether library-options was given.  */
  int quiet_given ;	/* Whether quiet was given.  */
  int system_configuration_file_given ;	/* Whether system-configuration-file was given.  */
  int ticket_write_file_given ;	/* Whether ticket-write-file was given.  */
  unsigned int verbose_given ;	/* Whether verbose was given.  */

  char **inputs ; /* unamed options */
  unsigned inputs_num ; /* unamed options number */
} ;

extern const char *gengetopt_args_info_purpose;
extern const char *gengetopt_args_info_usage;
extern const char *gengetopt_args_info_help[];

int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* SHISHI_CMD_H */
